/* UtilsView.c generated by valac 0.56.17, the Vala compiler
 * generated from UtilsView.vala, do not modify */

/*
 * Copyright 2018 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include "granite-7.h"

#define UTILS_VIEW_CSS "\n" \
"        .contrast-demo {\n" \
"            background: %s;\n" \
"            color: %s;\n" \
"            text-shadow: none;\n" \
"        }\n" \
"    "
#define UTILS_VIEW_DARK_BG "#273445"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_UTILS_VIEW (utils_view_get_type ())
#define UTILS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UTILS_VIEW, UtilsView))
#define UTILS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UTILS_VIEW, UtilsViewClass))
#define IS_UTILS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UTILS_VIEW))
#define IS_UTILS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UTILS_VIEW))
#define UTILS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UTILS_VIEW, UtilsViewClass))

typedef struct _UtilsView UtilsView;
typedef struct _UtilsViewClass UtilsViewClass;
typedef struct _UtilsViewPrivate UtilsViewPrivate;
enum  {
	UTILS_VIEW_0_PROPERTY,
	UTILS_VIEW_NUM_PROPERTIES
};
static GParamSpec* utils_view_properties[UTILS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;

struct _UtilsView {
	GtkGrid parent_instance;
	UtilsViewPrivate * priv;
};

struct _UtilsViewClass {
	GtkGridClass parent_class;
};

struct _UtilsViewPrivate {
	GtkStyleContext* demo_label_style_context;
};

struct _Block8Data {
	int _ref_count_;
	UtilsView* self;
	GdkRGBA gdk_demo_bg;
};

struct _Block9Data {
	int _ref_count_;
	Block8Data * _data8_;
	GtkColorChooserDialog* dialog;
};

static gint UtilsView_private_offset;
static gpointer utils_view_parent_class = NULL;

VALA_EXTERN GType utils_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UtilsView, g_object_unref)
static void utils_view_style_contrast_demo (UtilsView* self,
                                     GdkRGBA* bg_color);
VALA_EXTERN UtilsView* utils_view_new (void);
VALA_EXTERN UtilsView* utils_view_construct (GType object_type);
static GObject * utils_view_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void _utils_view___lambda10_ (Block8Data* _data8_);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda11_ (Block9Data* _data9_);
static void ___lambda11__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void __utils_view___lambda10__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self);
static void utils_view_finalize (GObject * obj);
static GType utils_view_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
utils_view_get_instance_private (UtilsView* self)
{
	return G_STRUCT_MEMBER_P (self, UtilsView_private_offset);
}

static void
utils_view_style_contrast_demo (UtilsView* self,
                                GdkRGBA* bg_color)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	gchar* css = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GdkRGBA _tmp3_;
	GdkRGBA _tmp4_ = {0};
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkStyleContext* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (bg_color != NULL);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	_tmp1_ = gdk_rgba_to_string (bg_color);
	_tmp2_ = _tmp1_;
	_tmp3_ = *bg_color;
	granite_contrasting_foreground_color (&_tmp3_, &_tmp4_);
	_tmp5_ = gdk_rgba_to_string (&_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strdup_printf (UTILS_VIEW_CSS, _tmp2_, _tmp6_);
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp6_);
	_g_free0 (_tmp2_);
	css = _tmp8_;
	gtk_css_provider_load_from_data (provider, (const char*) ((guint8*) css), (gssize) -1);
	_tmp9_ = self->priv->demo_label_style_context;
	gtk_style_context_add_provider (_tmp9_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_g_free0 (css);
	_g_object_unref0 (provider);
}

UtilsView*
utils_view_construct (GType object_type)
{
	UtilsView * self = NULL;
	self = (UtilsView*) g_object_new (object_type, NULL);
	return self;
}

UtilsView*
utils_view_new (void)
{
	return utils_view_construct (TYPE_UTILS_VIEW);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		UtilsView* self;
		self = _data8_->self;
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		UtilsView* self;
		self = _data9_->_data8_->self;
		_g_object_unref0 (_data9_->dialog);
		block8_data_unref (_data9_->_data8_);
		_data9_->_data8_ = NULL;
		g_slice_free (Block9Data, _data9_);
	}
}

static void
__lambda11_ (Block9Data* _data9_)
{
	Block8Data* _data8_;
	UtilsView* self;
	GtkColorChooserDialog* _tmp0_;
	GdkRGBA _tmp1_ = {0};
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
	GtkColorChooserDialog* _tmp4_;
	_data8_ = _data9_->_data8_;
	self = _data8_->self;
	_tmp0_ = _data9_->dialog;
	gtk_color_chooser_get_rgba ((GtkColorChooser*) _tmp0_, &_tmp1_);
	_tmp2_ = _tmp1_;
	_data8_->gdk_demo_bg = _tmp2_;
	_tmp3_ = _data8_->gdk_demo_bg;
	utils_view_style_contrast_demo (self, &_tmp3_);
	_tmp4_ = _data9_->dialog;
	gtk_window_destroy ((GtkWindow*) _tmp4_);
}

static void
___lambda11__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
	__lambda11_ (self);
}

static void
_utils_view___lambda10_ (Block8Data* _data8_)
{
	UtilsView* self;
	Block9Data* _data9_;
	GtkColorChooserDialog* _tmp0_;
	GtkColorChooserDialog* _tmp1_;
	GtkColorChooserDialog* _tmp2_;
	GdkRGBA _tmp3_;
	GtkColorChooserDialog* _tmp4_;
	GtkColorChooserDialog* _tmp5_;
	self = _data8_->self;
	_data9_ = g_slice_new0 (Block9Data);
	_data9_->_ref_count_ = 1;
	_data9_->_data8_ = block8_data_ref (_data8_);
	_tmp0_ = (GtkColorChooserDialog*) gtk_color_chooser_dialog_new ("", NULL);
	g_object_ref_sink (_tmp0_);
	_data9_->dialog = _tmp0_;
	_tmp1_ = _data9_->dialog;
	gtk_window_set_deletable ((GtkWindow*) _tmp1_, FALSE);
	_tmp2_ = _data9_->dialog;
	_tmp3_ = _data8_->gdk_demo_bg;
	gtk_color_chooser_set_rgba ((GtkColorChooser*) _tmp2_, &_tmp3_);
	_tmp4_ = _data9_->dialog;
	g_signal_connect_data ((GtkDialog*) _tmp4_, "response", (GCallback) ___lambda11__gtk_dialog_response, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
	_tmp5_ = _data9_->dialog;
	gtk_widget_show ((GtkWidget*) _tmp5_);
	block9_data_unref (_data9_);
	_data9_ = NULL;
}

static void
__utils_view___lambda10__gtk_button_clicked (GtkButton* _sender,
                                             gpointer self)
{
	_utils_view___lambda10_ (self);
}

static GObject *
utils_view_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	UtilsView * self;
	Block8Data* _data8_;
	GtkLabel* tooltip_markup_label = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkButton* tooltip_button_one = NULL;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GtkButton* tooltip_button_two = NULL;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GtkLabel* contrasting_foreground_color_label = NULL;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkButton* contrast_demo_button = NULL;
	GtkButton* _tmp22_;
	GtkButton* _tmp23_;
	GtkButton* _tmp24_;
	GtkStyleContext* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkStyleContext* _tmp27_;
	GtkLabel* _tmp28_;
	GtkButton* _tmp29_;
	GtkButton* _tmp30_;
	GtkLabel* _tmp31_;
	GtkButton* _tmp32_;
	GdkRGBA _tmp33_;
	GtkButton* _tmp34_;
	parent_class = G_OBJECT_CLASS (utils_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UTILS_VIEW, UtilsView);
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_data8_->self = g_object_ref (self);
	_tmp0_ = (GtkLabel*) gtk_label_new ("Markup Accel Tooltips:");
	g_object_ref_sink (_tmp0_);
	tooltip_markup_label = _tmp0_;
	_tmp1_ = tooltip_markup_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_END);
	_tmp2_ = (GtkButton*) gtk_button_new_from_icon_name ("mail-reply-all");
	g_object_ref_sink (_tmp2_);
	tooltip_button_one = _tmp2_;
	_tmp3_ = tooltip_button_one;
	_tmp4_ = g_strdup ("<Ctrl><Shift>R");
	_tmp5_ = g_strdup ("R");
	_tmp6_ = g_new0 (gchar*, 2 + 1);
	_tmp6_[0] = _tmp4_;
	_tmp6_[1] = _tmp5_;
	_tmp7_ = _tmp6_;
	_tmp7__length1 = 2;
	_tmp8_ = granite_markup_accel_tooltip (_tmp7_, (gint) 2, "Reply All");
	_tmp9_ = _tmp8_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp3_, _tmp9_);
	_g_free0 (_tmp9_);
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
	_tmp10_ = (GtkButton*) gtk_button_new_with_label ("Label Buttons");
	g_object_ref_sink (_tmp10_);
	tooltip_button_two = _tmp10_;
	_tmp11_ = tooltip_button_two;
	_tmp12_ = g_strdup ("<Super>R");
	_tmp13_ = g_strdup ("<Ctrl><Shift>Up");
	_tmp14_ = g_strdup ("<Ctrl>Return");
	_tmp15_ = g_strdup ("<Super>");
	_tmp16_ = g_new0 (gchar*, 4 + 1);
	_tmp16_[0] = _tmp12_;
	_tmp16_[1] = _tmp13_;
	_tmp16_[2] = _tmp14_;
	_tmp16_[3] = _tmp15_;
	_tmp17_ = _tmp16_;
	_tmp17__length1 = 4;
	_tmp18_ = granite_markup_accel_tooltip (_tmp17_, (gint) 4, NULL);
	_tmp19_ = _tmp18_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp11_, _tmp19_);
	_g_free0 (_tmp19_);
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
	_tmp20_ = (GtkLabel*) gtk_label_new ("Contrasting Foreground Color:");
	g_object_ref_sink (_tmp20_);
	contrasting_foreground_color_label = _tmp20_;
	_tmp21_ = contrasting_foreground_color_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_END);
	_tmp22_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp22_);
	contrast_demo_button = _tmp22_;
	_tmp23_ = contrast_demo_button;
	gtk_button_set_label (_tmp23_, "Contrast Demo");
	_tmp24_ = contrast_demo_button;
	_tmp25_ = gtk_widget_get_style_context ((GtkWidget*) _tmp24_);
	_tmp26_ = _g_object_ref0 (_tmp25_);
	_g_object_unref0 (self->priv->demo_label_style_context);
	self->priv->demo_label_style_context = _tmp26_;
	_tmp27_ = self->priv->demo_label_style_context;
	gtk_style_context_add_class (_tmp27_, "contrast-demo");
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 12);
	_tmp28_ = tooltip_markup_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp28_, 0, 0, 1, 1);
	_tmp29_ = tooltip_button_one;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp29_, 1, 0, 1, 1);
	_tmp30_ = tooltip_button_two;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp30_, 2, 0, 1, 1);
	_tmp31_ = contrasting_foreground_color_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp31_, 0, 1, 1, 1);
	_tmp32_ = contrast_demo_button;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp32_, 1, 1, 2, 1);
	memset (&_data8_->gdk_demo_bg, 0, sizeof (GdkRGBA));
	gdk_rgba_parse (&_data8_->gdk_demo_bg, UTILS_VIEW_DARK_BG);
	_tmp33_ = _data8_->gdk_demo_bg;
	utils_view_style_contrast_demo (self, &_tmp33_);
	_tmp34_ = contrast_demo_button;
	g_signal_connect_data (_tmp34_, "clicked", (GCallback) __utils_view___lambda10__gtk_button_clicked, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	_g_object_unref0 (contrast_demo_button);
	_g_object_unref0 (contrasting_foreground_color_label);
	_g_object_unref0 (tooltip_button_two);
	_g_object_unref0 (tooltip_button_one);
	_g_object_unref0 (tooltip_markup_label);
	block8_data_unref (_data8_);
	_data8_ = NULL;
	return obj;
}

static void
utils_view_class_init (UtilsViewClass * klass,
                       gpointer klass_data)
{
	utils_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UtilsView_private_offset);
	G_OBJECT_CLASS (klass)->constructor = utils_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = utils_view_finalize;
}

static void
utils_view_instance_init (UtilsView * self,
                          gpointer klass)
{
	self->priv = utils_view_get_instance_private (self);
}

static void
utils_view_finalize (GObject * obj)
{
	UtilsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UTILS_VIEW, UtilsView);
	_g_object_unref0 (self->priv->demo_label_style_context);
	G_OBJECT_CLASS (utils_view_parent_class)->finalize (obj);
}

static GType
utils_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UtilsViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) utils_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UtilsView), 0, (GInstanceInitFunc) utils_view_instance_init, NULL };
	GType utils_view_type_id;
	utils_view_type_id = g_type_register_static (gtk_grid_get_type (), "UtilsView", &g_define_type_info, 0);
	UtilsView_private_offset = g_type_add_instance_private (utils_view_type_id, sizeof (UtilsViewPrivate));
	return utils_view_type_id;
}

GType
utils_view_get_type (void)
{
	static volatile gsize utils_view_type_id__once = 0;
	if (g_once_init_enter (&utils_view_type_id__once)) {
		GType utils_view_type_id;
		utils_view_type_id = utils_view_get_type_once ();
		g_once_init_leave (&utils_view_type_id__once, utils_view_type_id);
	}
	return utils_view_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

